<?php

namespace EventPortal\Tests\Unit\Event\Form\Actions;

use EventPortal\Domain\Event\Form\Actions\UpdateForm;
use EventPortal\Domain\Event\Form\Enums\FormType;
use EventPortal\Domain\Event\Form\Models\Form;
use EventPortal\Domain\Event\Models\Event;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;

class UpdateFormTest extends TestCase
{
    use RefreshDatabase;

    /** @test **/
    public function can_update_a_form(): void
    {
        $event = factory(Event::class)->create();
        $form = factory(Form::class)->create(['event_id' => $event->id]);

        (new UpdateForm)->execute($event, $form, $this->getUpdatedFormData());

        $form = Form::first();
        $this->assertEquals('Updated test form', $form->name);
        $this->assertEquals(FormType::Registration()->getValue(), $form->type);
    }

    private function getUpdatedFormData(array $override = []): array
    {
        return array_merge([
            'name' => 'Updated test form',
            'type' => [
                'value' => FormType::Registration()->getValue(),
            ],
        ], $override);
    }
}
